; FILENAME      LD51EX1.ASM
; DESCRIPTION   LD51 EXAMPLE 1 (8255 USER PORT)
; HARDWARE      ANT-C51M
; ASSEMBLER     SXA51
; START-DATE    01/10/2540
; SOFTWARE ENG  JARAN CH.
; COMPANY       SILA RESEARCH CO.,LTD.
;               TEL 712-2850-2 FAX 381-1447

; ********** VARIABLE **********

         ORG    0032H

DISBUF:  DS     8
ADDIXX:  DS     2
ADDIYY:  DS     2

USRA     EQU    0FC00H            ;PORT A
USRB     EQU    0FC01H            ;PORT B
USRC     EQU    0FC02H            ;PORT C
USRP     EQU    0FC03H            ;CONTROL PORT

         $INCLUDE "LD51H.ASM"

; ********** MAIN **********
; TEST 8255,DISPLAY

         ORG    8100H

MAIN:    MOV    DPTR,#USRP
         MOV    A,#80H
         MOVX   @DPTR,A

ST2A:    CALL   ST2SUB
         SJMP   ST2A

ST2SUB:  MOV    ADDIYY,#2         ;**** TEST 8255 SUB ****
ST2SUB1: MOV    ADDIYY+1,#18
         MOV    DPTR,#TB8255
         MOV    ADDIXX,DPH
         MOV    ADDIXX+1,DPL

ST2SUB2: MOV    DPH,ADDIXX
         MOV    DPL,ADDIXX+1
         CLR    A
         MOVC   A,@A+DPTR
         INC    DPTR
         MOV    ADDIXX,DPH
         MOV    ADDIXX+1,DPL

         MOV    R4,#3             ;OUT TO 8255
         MOV    DPTR,#USRA
ST2SUB4: MOVX   @DPTR,A
         INC    DPTR
         DJNZ   R4,ST2SUB4

         MOV    R2,#8             ;LOAD TO DISBUF
         MOV    R0,#DISBUF
ST2SUB5: MOV    @R0,A
         INC    R0
         DJNZ   R2,ST2SUB5

         MOV    R2,#5
         CALL   DTSEC
         DJNZ   ADDIYY+1,ST2SUB2
         DJNZ   ADDIYY,ST2SUB1
         RET

TB8255:  DB     00000001B
         DB     00000010B
         DB     00000100B
         DB     00001000B
         DB     00010000B
         DB     00100000B
         DB     01000000B
         DB     10000000B
         DB     00000000B
         DB     11111111B
         DB     00000000B
         DB     11111111B
         DB     00000000B
         DB     10101010B
         DB     01010101B
         DB     10101010B
         DB     01010101B
         DB     00000000B

         END

